#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <unistd.h>
#include <limits.h>
#include <errno.h>
#include <string.h>

#define MAX_LENGTH 256

int main(int argc, char **argv)
{

	int passlen, i, tag, fd, res;
	/*здесь passlen - длина проля, i - счетчик для циклов,
	tag - случайное число, по которому выбираем диапазон таблицы символов,
	fd и res - дескриптор файла и результат некоторых функций*/
	
	unsigned short seeding[3];
	//массив, куда будем сеять биты//
	
	char password[MAX_LENGTH], c, confirm = 'a';
	//password - массив под пароль, c - символ для читающих циклов, confirm - ответ на запрос пользователю//

	printf("Enter the length of the password: ");
	scanf("%i", &passlen);
	if (passlen > MAX_LENGTH) {
		printf("You entered too big length.\n");
		exit(1);
	}

	fd = open("/dev/random", O_RDONLY); // /dev/random -генератор случайных чисел, встроенный в ядро, читайте random(4)//
	if (fd == -1) {
		printf("Random isn't initialized.\n");
		exit(1);
	}
	
	res = read(fd, seeding, 3); //заполняем посев случайными битами из /dev/random //
	if (res == -1) {
		printf("Seeding wasn't extracted.\n");
		exit(1);
	}

	seed48(seeding); //собираем урожай - теперь функция lrand48(3) будет возвращать всегда разное значение//
	
	/*теперь каждый символ пароля заполняем случайным знаком,
	чтобы понять эту конструкцию, посмотрите таблицу символов ASCII*/
	for (i = 0; i < passlen; i++) {
		tag = lrand48() % 3;
		
		switch (tag) {
			case 0:
				password[i] = (char)(48 + lrand48() % 10);
				break;
			case 1:
				password[i] = (char)(65 + lrand48() % 26);
				break;
			case 2:
				password[i] = (char)(97 + lrand48() % 26);
				break;
			default:
				printf("Tag has bad value.\n");
				exit(1);
		}
	}

	//Выводим пароль на экран, чтобы было не так грустно//
	printf("Password: ");

	for (i = 0; i < passlen; i++) {
		printf("%c", password[i]);
	}

	printf("\n");

	//пустой цикл чистит ввод//
	while (((c = getchar())!='\0') && (c != '\n')) {}

	do {
		printf("Save this password in a file? (y/n) ");
		confirm = getchar();
		/*считываем первый знак, остальной ввод чистим пустым циклом
		до тех пор, пока пользователь не введет адекватный ответ*/
		while (((c = getchar())!='\0') && (c != '\n')) {}
		
	} while ( (confirm != 'y') && (confirm != 'n') && (confirm != 'Y') && (confirm != 'N') );

	close(fd);

	//если пользователь решил вывести пароль в файл, то реализуется то, что ниже//
	if ( (confirm == 'y') || (confirm == 'Y') ) {
		int pathlen, namelen; //длины пути к файлу и имени его соответственно//
		char *filename, *path, *pathname; //массивы, в которых мы будем все это добро хранить. В pathname храниться конкатенация пути и имени//
		
		filename = malloc(sizeof(char));
		if (filename == NULL) {
			printf("Memory allocating for filename is failed.\n");
			exit(1);
		}
		
		path = malloc(sizeof(char));
		if (path == NULL) {
			printf("Memory allocating for path is failed.\n");
			exit(1);
		}

		printf("Enter the path: ");
		//просим ввести пароль и считываем его//
		for (pathlen = 0; ( ((c = getchar()) != EOF) && (c != '\n') && (pathlen != PATH_MAX) ); pathlen++) {
		
			if ( realloc(path, sizeof(char)*(pathlen+1)) == NULL) {
				printf("Memory reallocating for path is failed.\n");
				exit(1);
			} else {
				path[pathlen] = c;
			}
		}

		printf("Enter the filename: ");
		//просим ввести имя файла, читаем...//
		for (namelen = 0; ( ((c = getchar()) != '\0') && (c != '\n') && (namelen != NAME_MAX) ); namelen++) {
		
			if ( realloc(filename, sizeof(char)*(namelen+1)) == NULL) {
				printf("Memory reallocating for filename is failed.\n");
				exit(1);
			} else {
				filename[namelen] = c;
			}
		}

		//смотрим, написал ли пользователь в конце пути значек /. Если нет, добавляем.//
		if (path[pathlen-1] != '/') {
			if ( realloc(path, sizeof(char)*(++pathlen)) == NULL) {
				printf("Path checking is failed.\n");
				exit(1);
			} else { path[pathlen-1] = '/'; }
		}

		/*смотрим, ввел ли пользователь в начале пути значек /.
		Если не ввел, и не поставил значек текущей папки, добавляем / */
		if ((path[0] != '/') && (path[0] != '.')) {
			if ( realloc(path, sizeof(char)*(++pathlen)) == NULL) {
				printf("Path checking is failed.\n");
				exit(1);
			} else {
				for (i = (pathlen-1); i > 0; i--) {
					path[i] = path[i-1];
				}
				path[0] = '/';
			}
		}

		//проводим конкатенацию пути и имени в pathname//
		pathname = malloc(sizeof(char) * (namelen + pathlen + 3));
		if (pathname == NULL) {
			printf("Memory allocating for pathname is failed.\n");
		}

		for (i = 0; i < pathlen; i++) {
			pathname[i] = path[i];
		}
		for (i = 0; i < namelen; i++) {
			pathname[i+pathlen] = filename[i];
		}

		//наконец, пытаемся открыть указанный пользователем файл//
		fd = open(pathname, O_WRONLY | O_CREAT | O_APPEND, S_IRUSR);
		if (fd == -1) {
			printf("%s.\n", strerror(errno));
			exit(1);
		}

		//если файл таки-открылся, то записываем туда пароль//
		res = write(fd, password, passlen);
		if (res == -1) {
			printf("%s\n.", strerror(errno));
			exit(1);
		}

		printf("Password was saved in ");
		//Ну, и для острастки, выводим на экран полдный путь с именем файла, в который мы сохранили пароль.//
		if (path[0] == '.') {
			if (realloc(path, PATH_MAX*sizeof(char)) == NULL) {
				printf("Memory allocating for path is failed.\n");
				exit(1);
			} else {
				path = get_current_dir_name();
				if (path == NULL) {
					printf(".");
				} else {
					for (i = 0; (path[i] != '\0'); i++) {
						printf("%c", path[i]);
					}
				}
			}
		}
		
		for (i = 1; i < (namelen + pathlen) ; i++) {
			printf("%c", pathname[i]);
		}

		printf("\n");
		
		close(fd);
		free(path);
		free(pathname);
		free(filename);
	}
	
	return 0;	
}
